' XPlanViewerWithTrace
'
' Original by Charles Hooper http://hoopercharles.wordpress.com/2010/02/11/automated-dbms_xplan-trace-and-send-to-excel/
' Modified by David Mann     http://ba6.us
'
' Purpose: Implement a tool to help automate Explain Plan and Tracing tasks using VBScript and IE
'
' Change log:
'  2010-02-11 | Charles Hooper | Version 1.0
'  2010-02-11 | David Mann     | Login enhancements including login screen and error checking




' Function:    getLoginInfo
' Description: This function uses Internet Explorer to create a dialog and prompt for user input.
' Author:      David Mann @ ba6.us
'              Adapted from code Written by Rob van der Woude http://www.robvanderwoude.com
' Arguments:   uname, pword, dbase as string
' Returns:     uname, pword, dbase as reference parameters
'
Sub getLoginInfo( uname, pword, dbase )

    Dim objIE

    ' Create an IE object
    Set objIE = CreateObject( "InternetExplorer.Application" )

    ' Specify some of the IE window's settings
    objIE.Navigate "about:blank"
    objIE.Document.Title = "Please enter login information..."
    objIE.ToolBar        = False
    objIE.Resizable      = False
    objIE.StatusBar      = False
    objIE.Width          = 320
    objIE.Height         = 200

    ' Center the dialog window on the screen
    With objIE.Document.ParentWindow.Screen
        objIE.Left = (.AvailWidth  - objIE.Width ) \ 2
        objIE.Top  = (.Availheight - objIE.Height) \ 2
    End With

    ' Wait till IE is ready
    Do While objIE.Busy
        WScript.Sleep 200
    Loop
    ' Insert the HTML code to prompt for user input
    strHTML = ""

    strHTML = strHTML & "<div align=""center"">" & vbCrLf
    strHTML = strHTML & "<TABLE>" & vbCrLf
    strHTML = strHTML & "<TR><TD>Username:</TD>" & vbCrLf
    strHTML = strHTML & "<TD><input type=""text"" size=""20"" id=""UserName""></TD></TR>" & vbCrLf
    strHTML = strHTML & "<TR><TD>Password:</TD>" & vbCrLf
    strHTML = strHTML & "<TD><input type=""password"" size=""20"" id=""PassWord""></TD></TR>" & vbCrLf
    strHTML = strHTML & "<TR><TD>Database:</TD>" & vbCrLf
    strHTML = strHTML & "<TD><input type=""text"" size=""20"" id=""DataBase""></TD></TR>" & vbCrLf
    strHTML = strHTML & "</TABLE>" & vbCrLf
    strHTML = strHTML & "<input type=""hidden"" id=""OK"" name=""OK"" value=""0"">" & vbCrLf
    strHTML = strHTML & "<input type=""submit"" value="" OK "" OnClick=""VBScript:OK.Value=1"">" & vbCrLf

    objIE.Document.Body.InnerHTML = strHTML
    
    
    ' Make the window visible
    objIE.Visible = True

    ' Wait till the OK button has been clicked
    On Error Resume Next
    Do While objIE.Document.All.OK.Value = 0
        WScript.Sleep 200
        ' Error handling code by Denis St-Pierre
        If Err Then ' user clicked red X (or alt-F4) to close IE window
            IELogin = Array( "", "" )
            objIE.Quit
            Set objIE = Nothing
            Exit Sub
        End if
    Loop
    On Error Goto 0

    ' Read the user input from the dialog window
    uname = objIE.Document.All.UserName.Value
    pword = objIE.Document.All.PassWord.Value
    dbase = objIE.Document.All.DataBase.Value

    ' Close and release the object
    objIE.Quit
    Set objIE = Nothing
End Sub




' Main program

On Error Resume Next


' First, try to login, if not successful, exit
Dim strUsername
Dim strPassword
Dim strDatabase
Call getLoginInfo(strUsername, strPassword, strDatabase)
Set dbDatabase = CreateObject("ADODB.Connection")
dbDatabase.ConnectionString = "Provider=OraOLEDB.Oracle;Data Source=" & strDatabase & ";User ID=" & strUsername & ";Password=" & strPassword & ";"
dbDatabase.Open
If dbDatabase.State <> 1 Then
  MsgBox("Error Opening Database Connection, Exiting")
  dbDatabase = Nothing
  WScript.Quit
End If



Const adCmdText = 1
Const adCmdStoredProc = 4
Const adParamInput = 1
Const adVarNumeric = 139
Const adBigInt = 20
Const adDecimal = 14
Const adDouble = 5
Const adInteger = 3
Const adLongVarBinary = 205
Const adNumeric = 131
Const adSingle = 4
Const adSmallInt = 2
Const adTinyInt = 16
Const adUnsignedBigInt = 21
Const adUnsignedInt = 19
Const adUnsignedSmallInt = 18
Const adUnsignedTinyInt = 17
Const adDate = 7
Const adDBDate = 133
Const adDBTimeStamp = 135
Const adDBTime = 134
Const adVarChar = 200
const adUseClient = 3



Dim strTemp
Dim strSQL                          'SQL statement
Dim strHTML                         'The raw HTML for the web page
Dim objIE                           'The Internet Explorer object
Dim objIE_XPLAN                     'The Internet Explorer object
Dim objExcel                        'For sending the output to Excel

Dim snpData                         'ADO Recordset object used to retrieve the user's data
Dim snpXPLAN                        'ADO Recordset object used to retrieve the execution plan
Dim comXPLAN                        'ADO command object used to retrieve the execution plan
Dim dbDatabase                      'ADO database connection object

Dim intTempCount                    'Counter of the number of Excel sheets that have been created
Dim intClose                        'Flag that indicates that the VBS script should end
Dim intFlag                         'Flag that indicates we should jump out of the loop that waits for user input

Dim strFormSQL                      'SQL statement entered by the user on the form
Dim strFormXPlanType                'User selected XPLAN type on the form
Dim strFormStatsLevel               'Selected Statistics Level
Dim strForm10046TraceType           'User selected 10046 trace type on the form
Dim strForm10053TraceType           'User selected 10053 trace type on the form
Dim strForm10032TraceType           'User selected 10032 trace type on the form
Dim strForm10033TraceType           'User selected 10033 trace type on the form
Dim strFormArrayFetch               'User select Fetch Array Size
Dim strTraceIdentifier              'Name of the trace file
Dim strSQLOutput                    'Up to the first 100 rows of the SQL statement
Dim strLastStatus                   'Last Error Message
Dim strLastColumn                   'Column identifier in Excel of the right-most column
 
Dim i                               'Counter
Dim intRowCount                     'Row counter for the SQL statement
Dim intColCount                     'Number of columns in the result set
Dim intColDataType(1000)            'Data type of the column from the SQL statement

 
Set snpData = CreateObject("ADODB.Recordset")
Set snpXPLAN = CreateObject("ADODB.Recordset")
Set comXPLAN = CreateObject("ADODB.Command")
 
snpData.CursorLocation = adUseClient
 
'Create an Excel connection
Set objExcel = CreateObject("Excel.Application")

'Set up to allow exporting, if requested
objExcel.DisplayAlerts = False
objExcel.Workbooks.Add

'Fire up Internet Explorer
Set objIE = CreateObject("InternetExplorer.Application")
objIE.Left = 0
objIE.Top = 0
objIE.Width = 1024
objIE.Height = 800
objIE.StatusBar = False
objIE.MenuBar = False
objIE.Toolbar = False

objIE.Navigate "about:blank"
objIE.Document.Title = "Charles Hooper's XPlan Viewer with Trace - Login: " & strUsername & "@" & strDatabase
objIE.Visible = True



'Should verify that the connection attempt was successful, but I will leave that for someone else to code

strLastStatus = "Ready"

With comXPLAN
  strSQL = "SELECT * FROM TABLE(DBMS_XPLAN.DISPLAY_CURSOR( ?, ?, ?))"
  
  'Add the bind variables
  .Parameters.Append .CreateParameter("sqlid", adVarChar, adParamInput, 40, Null)
  .Parameters.Append .CreateParameter("childnumber", adNumeric, adParamInput, 8, Null)
  .Parameters.Append .CreateParameter("format", adVarChar, adParamInput, 100, "TYPICAL")
        
  .CommandText = strSQL
  .CommandType = adCmdText
  .CommandTimeout = 30
  .ActiveConnection = dbDatabase
End With
 
intClose = False
 
'Set the default values
strFormSQL = ""
strFormXPlanType = "TYPICAL"
strFormStatsLevel = "TYPICAL"
strForm10046TraceType = "Disabled"
strForm10053TraceType = "Disabled"
strForm10032TraceType = "Disabled"
strForm10033TraceType = "Disabled"
strFormArrayFetch = "100"

Do While intClose = False
  strHTML = ""

  strHTML = strHTML & "<form name=""OracleXplanViewer"">" & vbCrLf
  strHTML = strHTML & "<input type=hidden id=txtOK value="" "">" & vbCrLf
  strHTML = strHTML & "<textarea rows=""30"" id=txtSQL cols=""120""></textarea>" & vbCrLf

  strHTML = strHTML & "<table>" & vbCrLf
  strHTML = strHTML & "<tr>" & vbCrLf
  strHTML = strHTML & "<td>DBMS_XPLAN Type<br><select size=""1"" id=cboXPlanType style=""width:150"">" & vbCrLf
  strHTML = strHTML & "<option value=""BASIC"">BASIC</option>" & vbCrLf
  strHTML = strHTML & "<option value=""TYPICAL"">TYPICAL</option>" & vbCrLf
  strHTML = strHTML & "<option value=""ALLSTATS"">ALLSTATS</option>" & vbCrLf
  strHTML = strHTML & "<option value=""ALLSTATS LAST"">ALLSTATS LAST</option>" & vbCrLf
  strHTML = strHTML & "</select></td>" & vbCrLf

  strHTML = strHTML & "<td>Stats Level<br><select size=""1"" id=cboStatsLevel style=""width:80"">" & vbCrLf
  strHTML = strHTML & "<option value=""TYPICAL"">TYPICAL</option>" & vbCrLf
  strHTML = strHTML & "<option value=""ALL"">ALL</option>" & vbCrLf
  strHTML = strHTML & "</select></td>" & vbCrLf
  
  strHTML = strHTML & "<td>10046 Trace Type<br><select size=""1"" id=cbo10046TraceType style=""width:150"">" & vbCrLf
  strHTML = strHTML & "<option value=""Disabled"">Disabled</option>" & vbCrLf
  strHTML = strHTML & "<option value=""Level 4 (Binds)"">Level 4 (Binds)</option>" & vbCrLf
  strHTML = strHTML & "<option value=""Level 8 (Waits)"">Level 8 (Waits)</option>" & vbCrLf
  strHTML = strHTML & "<option value=""Level 12 (Waits and Binds)"">Level 12 (Waits and Binds)</option>" & vbCrLf
  strHTML = strHTML & "</select></td>" & vbCrLf
  
  strHTML = strHTML & "<td>10053 Trace Type<br><select size=""1"" id=cbo10053TraceType style=""width:150"">" & vbCrLf
  strHTML = strHTML & "<option value=""Disabled"">Disabled</option>" & vbCrLf
  strHTML = strHTML & "<option value=""Level 1"">Level 1</option>" & vbCrLf
  strHTML = strHTML & "<option value=""Level 2"">Level 2</option>" & vbCrLf
  strHTML = strHTML & "</select></td>" & vbCrLf
  
  strHTML = strHTML & "<td>10032 Trace Type<br><select size=""1"" id=cbo10032TraceType style=""width:150"">" & vbCrLf
  strHTML = strHTML & "<option value=""Disabled"">Disabled</option>" & vbCrLf
  strHTML = strHTML & "<option value=""Enabled"">Enabled</option>" & vbCrLf
  strHTML = strHTML & "</select></td>" & vbCrLf

  strHTML = strHTML & "<td>10033 Trace Type<br><select size=""1"" id=cbo10033TraceType style=""width:150"">" & vbCrLf
  strHTML = strHTML & "<option value=""Disabled"">Disabled</option>" & vbCrLf
  strHTML = strHTML & "<option value=""Enabled"">Enabled</option>" & vbCrLf
  strHTML = strHTML & "</select></td>" & vbCrLf

  strHTML = strHTML & "<td>Array Fetch Size<br><select size=""1"" id=cboArrayFetch style=""width:100"">" & vbCrLf
  strHTML = strHTML & "<option value=""1"">1</option>" & vbCrLf
  strHTML = strHTML & "<option value=""2"">2</option>" & vbCrLf
  strHTML = strHTML & "<option value=""5"">5</option>" & vbCrLf
  strHTML = strHTML & "<option value=""10"">10</option>" & vbCrLf
  strHTML = strHTML & "<option value=""15"">15</option>" & vbCrLf
  strHTML = strHTML & "<option value=""20"">20</option>" & vbCrLf
  strHTML = strHTML & "<option value=""50"">50</option>" & vbCrLf
  strHTML = strHTML & "<option value=""100"">100</option>" & vbCrLf
  strHTML = strHTML & "<option value=""200"">200</option>" & vbCrLf
  strHTML = strHTML & "<option value=""500"">500</option>" & vbCrLf
  strHTML = strHTML & "<option value=""1000"">1000</option>" & vbCrLf
  strHTML = strHTML & "</select></td>" & vbCrLf
  strHTML = strHTML & "</tr>" & vbCrLf
  strHTML = strHTML & "</table>" & vbCrLf
  strHTML = strHTML & "<br>" & vbCrLf
  strHTML = strHTML & "<input type=button value=""XPlan"" onclick=""document.getElementById('txtOK').value='XPLAN';"">" & vbCrLf
  strHTML = strHTML & "<input type=button value=""Send to Excel"" id=cmdExcel onclick=""document.getElementById('txtOK').value='EXCEL';"">" & vbCrLf
  strHTML = strHTML & "<input type=button value=""Close"" id=cmdClose onclick=""document.getElementById('txtOK').value='CLOSE';""><br>" & vbCrLf
  strHTML = strHTML & "Status: <input type=text id=txtStatus value="" "" size=130 disabled=true><br />" & vbCrLf
  strHTML = strHTML & "</form>" & vbCrLf
  strHTML = strHTML & "<hr>" & vbCrLf

  strHTML = strHTML & strSQLOutput
 
  objIE.Document.Body.InnerHTML = strHTML
 
 
  'Put the VBS script into suspend mode for 1/2 second to prevent hammering the CPUs
  Wscript.Sleep 200
 
  'Restore the previously entered values in the form
  objIE.Document.All.txtSQL.Value = strFormSQL
  objIE.Document.All.cboXPlanType.Value = strFormXPlanType
  objIE.Document.All.cboStatsLevel.Value = strFormStatsLevel
  objIE.Document.All.cbo10046TraceType.Value = strForm10046TraceType
  objIE.Document.All.cbo10053TraceType.Value = strForm10053TraceType
  objIE.Document.All.cbo10032TraceType.Value = strForm10032TraceType
  objIE.Document.All.cbo10033TraceType.Value = strForm10033TraceType
  objIE.Document.All.cboArrayFetch.Value = strFormArrayFetch
  objIE.Document.All.txtStatus.Value = strLastStatus
  intFlag = 0

  strLastStatus = ""
  Do While intFlag = 0
    'Put the VBS script into suspend mode for 1/2 second to prevent hammering the CPUs
    Wscript.Sleep 500

    If objIE Is Nothing Then
      'User closed the Window
      intFlag = -1
    Else
      strTemp = objIE.Document.All.txtOK.Value
      If strTemp = "XPLAN" Then
        intFlag = 1
        
        'Record the values entered on the form
         strFormSQL = Trim(objIE.Document.All.txtSQL.Value)
        If Right(strFormSQL, 1) = ";" Then
          strFormSQL = Left(strFormSQL, Len(strFormSQL) - 1)
        End If
        strFormXPlanType = objIE.Document.All.cboXPlanType.Value
        strFormStatsLevel = objIE.Document.All.cboStatsLevel.Value
        strForm10046TraceType = objIE.Document.All.cbo10046TraceType.Value
        strForm10053TraceType = objIE.Document.All.cbo10053TraceType.Value
        strForm10032TraceType = objIE.Document.All.cbo10032TraceType.Value
        strForm10033TraceType = objIE.Document.All.cbo10033TraceType.Value
        strFormArrayFetch = objIE.Document.All.cboArrayFetch.Value
      End If
      
      If strTemp = "CLOSE" Then
        intFlag = -1
      End If
      
      If strTemp = "EXCEL" Then
        objIE.Document.Body.All.txtStatus.Value = "Opening Dataset in Excel"
        Err = 0
        strFormSQL = Trim(objIE.Document.All.txtSQL.Value)
        If Right(strFormSQL, 1) = ";" Then
          strFormSQL = Left(strFormSQL, Len(strFormSQL) - 1)
        End If
        snpData.Open strFormSQL, dbDatabase
      
        If snpData.State = 1 Then
          If Not (snpData.EOF) Then
            With objExcel
              intTempCount = intTempCount + 1
              .Visible = True
              .ActiveWorkbook.Sheets.Add
              .ActiveSheet.Name = "ExcelExport" & CStr(intTempCount)
                    
               For i = 0 To snpData.Fields.Count - 1
                 .ActiveSheet.Cells(1, i + 1).Value = snpData.Fields(i).Name
               Next
               .ActiveSheet.Range(.ActiveSheet.Cells(1, 1), .ActiveSheet.Cells(1, snpData.Fields.Count)).Font.Bold = True
               
               'Format the columns in the spreadsheet
               For i = 0 To snpData.Fields.Count - 1
                 strLastColumn = Chr(64 + Int((i + 3) / 26)) & Chr(64 + ((i + 3) Mod 26 + 1))
                 .Columns(strLastColumn).Select
                 Select Case intColDataType(i)
                   Case adDate, adDBDate, adDBTimeStamp, adDBTime
                     .Selection.HorizontalAlignment = -4152
                     .Selection.NumberFormat = "mm/dd/yy hh:nn AM/PM"
                   Case adBigInt, adInteger, adSmallInt, adTinyInt, adUnsignedBigInt, adUnsignedInt, adUnsignedSmallInt, adUnsignedTinyInt
                     .Selection.HorizontalAlignment = -4152
                     .Selection.NumberFormat = "0"
                   Case adVarNumeric, adDecimal, adDouble, adNumeric, adSingle
                     .Selection.HorizontalAlignment = -4152
                     .Selection.NumberFormat = "0.0000"
                   Case adVarChar
                     .Selection.HorizontalAlignment = -4131
                     .Selection.NumberFormat = "@"
                 End Select
               Next
        
               strLastColumn = Chr(64 + Int((snpData.Fields.Count + 2) / 26)) & Chr(64 + ((snpData.Fields.Count + 2) Mod 26 + 1))
               .ActiveSheet.Range("A2").CopyFromRecordset snpData
                               
               'Auto-fit up to columns
               .ActiveSheet.Columns("A:" & strLastColumn).AutoFit
               .ActiveSheet.Range("B2").Select
               .ActiveWindow.FreezePanes = True
    
               .Application.DisplayAlerts = False
               'Remove the default worksheets
               If intTempCount = 1 Then
                 For i = 1 To ActiveWorkbook.Sheets.Count
                   If .ActiveWorkbook.Sheets(i).Name = "Sheet1" Then
                     .Sheets("Sheet1").Select
                     .ActiveWindow.SelectedSheets.Delete
                   End If
                   If .ActiveWorkbook.Sheets(i).Name = "Sheet2" Then
                     .Sheets("Sheet2").Select
                     .ActiveWindow.SelectedSheets.Delete
                   End If
                   If .ActiveWorkbook.Sheets(i).Name = "Sheet3" Then
                     .Sheets("Sheet3").Select
                     .ActiveWindow.SelectedSheets.Delete
                   End If
                 Next
               End If
            End With
            objIE.Document.Body.All.txtStatus.Value = ""
          Else
            objIE.Document.Body.All.txtStatus.Value = "No Rows Returned"
          End If
        Else
          objIE.Document.Body.All.txtStatus.Value = "Could Not Open the SQL Statement " & Error
        End If
        snpData.Close
      Else
        
      End If
      
      objIE.Document.All.txtOK.Value = ""
      strTemp = ""
      Wscript.Sleep 500
    End If

    If Err = -2147417848 Then
      'The object invoked has disconnected from its clients.
      intFlag = -1
    End If
    
    If Abs(intFlag) = 1 Then
      Exit Do
    End If
  Loop

  If intFlag = -1 Then
    intClose = True
  End If
  
  If intFlag = 1 Then
    strTraceIdentifier = "XPLAN" & DatePart("yyyy", Now) & "-" & DatePart("m", Now) & "-" & DatePart("d", Now) & _
                         "-" & DatePart("h", Now) & "-" & DatePart("n", Now) & "-" & DatePart("s", Now)

    If (strForm10046TraceType <> "Disabled") Or (strForm10053TraceType <> "Disabled") _
      Or (strForm10032TraceType <> "Disabled") Or (strForm10033TraceType <> "Disabled") Then
        dbDatabase.Execute "ALTER SESSION SET TRACEFILE_IDENTIFIER = '" & strTraceIdentifier & "'"
    End If

    If strFormStatsLevel = "ALL" Then
      dbDatabase.Execute "ALTER SESSION SET STATISTICS_LEVEL = 'ALL'"
    End If
    
    Select Case strForm10046TraceType
      Case "Level 4 (Binds)"
        dbDatabase.Execute "ALTER SESSION SET EVENTS '10046 TRACE NAME CONTEXT FOREVER, LEVEL 4'"
      Case "Level 8 (Waits)"
        dbDatabase.Execute "ALTER SESSION SET EVENTS '10046 TRACE NAME CONTEXT FOREVER, LEVEL 8'"
      Case "Level 12 (Waits and Binds)"
        dbDatabase.Execute "ALTER SESSION SET EVENTS '10046 TRACE NAME CONTEXT FOREVER, LEVEL 12'"
    End Select
    
    'Case statements are used here to make it easy to add additional trace levels
    Select Case strForm10053TraceType
      Case "Level 1"
        dbDatabase.Execute "ALTER SESSION SET EVENTS '10053 TRACE NAME CONTEXT FOREVER, LEVEL 1'"
      Case "Level 2"
        dbDatabase.Execute "ALTER SESSION SET EVENTS '10053 TRACE NAME CONTEXT FOREVER, LEVEL 2'"
    End Select
    
    Select Case strForm10032TraceType
      Case "Enabled"
        dbDatabase.Execute "ALTER SESSION SET EVENTS '10032 TRACE NAME CONTEXT FOREVER, LEVEL 10'"
    End Select
    
    Select Case strForm10033TraceType
      Case "Enabled"
        dbDatabase.Execute "ALTER SESSION SET EVENTS '10033 TRACE NAME CONTEXT FOREVER, LEVEL 10'"
    End Select
    
    'Provide a little time (200ms) for the above ALTER SESSION commands to take effect
    Wscript.Sleep 200
    
    If strFormSQL <> "" Then
      objIE.Document.All.txtStatus.Value = "Executing Query"
      
      Err = 0
      snpData.Open strFormSQL, dbDatabase
      
      If snpData.State = 1 Then
        objIE.Document.All.txtStatus.Value = "Query Opened"
        snpData.CacheSize = CLng(strFormArrayFetch)
        
        'Provide a little time (200ms) for the above CacheSize commands to take effect
        Wscript.Sleep 200

        strSQLOutput = "<table border=""1"" style=""font-family: Courier New; font-size: 8pt"">" & vbCrLf
        strSQLOutput = strSQLOutput & "<tr>" & vbCrLf
        
        intColCount = snpData.Fields.Count
        For i = 0 To intColCount - 1
          intColDataType(i) = snpData.Fields(i).Type
          strSQLOutput = strSQLOutput & "<td>" & snpData.Fields(i).Name & "</td>" & vbCrLf
        Next
        strSQLOutput = strSQLOutput & "</tr>" & vbCrLf
        
        intRowCount = 0
        objIE.Document.All.txtStatus.Value = "Retrieving Query Rows"
        Do While Not (snpData.EOF)
          If intRowCount < 100 Then
            'Only write the first 100 rows to the web page
            intRowCount = intRowCount + 1
            strSQLOutput = strSQLOutput & "<tr>" & vbCrLf
            For i = 0 To intColCount - 1
              If Not (IsNull(snpData(i))) Then
                Select Case intColDataType(i)
                  Case adDate, adDBDate, adDBTimeStamp, adDBTime
                    strSQLOutput = strSQLOutput & "  <td style=""text-align: right"">" & FormatDateTime(snpData(i), 2) & "</td>" & vbCrLf
                  Case adBigInt, adInteger, adSmallInt, adTinyInt, adUnsignedBigInt, adUnsignedInt, adUnsignedSmallInt, adUnsignedTinyInt
                    strSQLOutput = strSQLOutput & "  <td style=""text-align: right"">" & FormatNumber(snpData(i), 4) & "</td>" & vbCrLf
                  Case adVarNumeric, adDecimal, adDouble, adNumeric, adSingle
                    strSQLOutput = strSQLOutput & "  <td style=""text-align: right"">" & FormatNumber(snpData(i), 4) & "</td>" & vbCrLf
                  Case adVarChar
                    strSQLOutput = strSQLOutput & "  <td>" & CStr(snpData(i)) & "</td>" & vbCrLf
                  Case Else
                    strSQLOutput = strSQLOutput & "  <td>" & CStr(snpData(i)) & "</td>" & vbCrLf
                End Select
              Else
                strSQLOutput = strSQLOutput & "  <td>&nbsp;</td>" & vbCrLf
              End If
            Next
            strSQLOutput = strSQLOutput & "</tr>" & vbCrLf
          End If
          
          snpData.MoveNext
        Loop
        snpData.Close
        
        strSQLOutput = strSQLOutput & "</table>" & vbCrLf
        
        objIE.Document.All.txtStatus.Value = "Retrieving Query Plan"
        'Fire up Internet Explorer to show the DBMS_XPLAN output
        Set objIE_XPLAN = CreateObject("InternetExplorer.Application")
        objIE_XPLAN.Left = 50
        objIE_XPLAN.Top = 50
        objIE_XPLAN.Width = 700
        objIE_XPLAN.Height = 500
        objIE_XPLAN.StatusBar = False
        objIE_XPLAN.MenuBar = False
        objIE_XPLAN.Toolbar = False
        Wscript.Sleep 200
        
        'Output the DBMS_XPLAN
        comXPLAN("format") = strFormXPlanType
        comXPLAN("sqlid") = Null
        comXPLAN("childnumber") = Null
        strHTML = ""
        Set snpXPLAN = comXPLAN.Execute
        If Not (snpXPLAN Is Nothing) Then
          If snpXPLAN.State = 1 Then
            strHTML = "<font face=""Courier New"" size=""1"">"
            Do While Not snpXPLAN.EOF
              strHTML = strHTML & Replace(snpXPLAN(0), " ", "&nbsp;") & "<br>" & vbCrLf
                                
              snpXPLAN.MoveNext
            Loop
            snpXPLAN.Close
            strHTML = strHTML & "</font>" & vbCrLf
          End If
        End If
        
        objIE_XPLAN.Navigate "about:blank"
        objIE_XPLAN.Document.Title = "Charles Hooper's XPLAN Viewer"
        objIE_XPLAN.Visible = True
        objIE_XPLAN.Document.Body.InnerHTML = strHTML
              
        Wscript.Sleep 200
        'Disconnect from the IE window
        Set objIE_XPLAN = Nothing
        strLastStatus = ""
      Else
        objIE.Document.All.txtStatus.Value = "Error Opening SQL Statement " & Error
        strLastStatus = "Error Opening SQL Statement " & Error
      End If
    End If
      
    Select Case strForm10046TraceType
      Case "Disabled"
        'Do nothing
      Case Else
        dbDatabase.Execute "ALTER SESSION SET EVENTS '10046 TRACE NAME CONTEXT OFF'"
    End Select
    
    Select Case strForm10053TraceType
      Case "Disabled"
        'Do nothing
      Case Else
        dbDatabase.Execute "ALTER SESSION SET EVENTS '10053 TRACE NAME CONTEXT OFF'"
    End Select

    Select Case strForm10032TraceType
      Case "Disabled"
        'Do nothing
      Case Else
        dbDatabase.Execute "ALTER SESSION SET EVENTS '10032 TRACE NAME CONTEXT OFF'"
    End Select
    
    Select Case strForm10033TraceType
      Case "Disabled"
        'Do nothing
      Case Else
        dbDatabase.Execute "ALTER SESSION SET EVENTS '10033 TRACE NAME CONTEXT FOREVER, LEVEL 10'"
    End Select

    If strFormStatsLevel = "ALL" Then
      'Reset back to typical
      dbDatabase.Execute "ALTER SESSION SET STATISTICS_LEVEL = 'TYPICAL'"
    End If

    If (strForm10046TraceType <> "Disabled") Or (strForm10053TraceType <> "Disabled") _
      Or (strForm10032TraceType <> "Disabled") Or (strForm10033TraceType <> "Disabled") Then
        strLastStatus = "Trace File Identifier: " & strTraceIdentifier
    End If
  End If
Loop


' Clean Up
objIE.Quit
If intTempCount = 0 Then
objExcel.Application.Quit
End If

Set objExcel = Nothing
Set objIE = Nothing
Set snpData = Nothing
Set snpXPLAN = Nothing
Set comXPLAN = Nothing
dbDatabase.Close
Set dbDatabase = Nothing
